/* GStreamer AAC+ (libaacplus Encoder) plugin
 * Copyright (C) 2011 Sergiy Guryev <piratfm@ua.fm>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#ifndef __GST_AACPLUS_H__
#define __GST_AACPLUS_H__

#include <gst/gst.h>
#include <gst/base/gstadapter.h>
#include <gst/audio/audio.h>
#include <aacplus.h>

G_BEGIN_DECLS

#define GST_TYPE_AACPLUS \
  (gst_aacplus_get_type ())
#define GST_AACPLUS(obj) \
  (G_TYPE_CHECK_INSTANCE_CAST ((obj), GST_TYPE_AACPLUS, GstAacPlus))
#define GST_AACPLUS_CLASS(klass) \
  (G_TYPE_CHECK_CLASS_CAST ((klass), GST_TYPE_AACPLUS, GstAacPlusClass))
#define GST_IS_AACPLUS(obj) \
  (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GST_TYPE_AACPLUS))
#define GST_IS_AACPLUS_CLASS(klass) \
  (G_TYPE_CHECK_CLASS_TYPE ((klass), GST_TYPE_AACPLUS))

typedef struct _GstAacPlus GstAacPlus;
typedef struct _GstAacPlusClass GstAacPlusClass;

struct _GstAacPlus {
  GstElement element;

  /* pads */
  GstPad *srcpad, *sinkpad;

  /* stream properties */
  gint samplerate,
       channels,
       format,
       bps,
       bitrate,
       outputformat;
  gulong bytes,
         samples;

  /* AACPLUS object */
  aacplusEncHandle handle;

  /* cache of the input */
  GstAdapter *adapter;
  /* offset of data to be encoded next */
  guint offset;
  /* ts for last buffer */
  GstClockTime next_ts;
};

struct _GstAacPlusClass {
  GstElementClass parent_class;
};

GType gst_aacplus_get_type (void);

G_END_DECLS

#endif /* __GST_AACPLUS_H__ */
